/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package pb138.domtest;

import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.Result;
import javax.xml.transform.Source;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;
import javax.xml.transform.stream.StreamSource;
import javax.xml.xpath.XPath;
import javax.xml.xpath.XPathConstants;
import javax.xml.xpath.XPathExpressionException;
import javax.xml.xpath.XPathFactory;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;
import org.w3c.dom.xpath.XPathEvaluator;
import org.xml.sax.ErrorHandler;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;

/**
 *
 * @author bar
 */
public class DomTest {
    
    private Document doc=null;

    public static void main(String[] args){
        try {
            DomTest domTest = new DomTest("books.xml");
            domTest.changeAuthor("Neznamy","Jan Novak");
            System.out.println(domTest.countPages());
            domTest.serialize("out.xml");
        } catch (TransformerConfigurationException ex) {
            Logger.getLogger(DomTest.class.getName()).log(Level.SEVERE, null, ex);
        } catch (TransformerException ex) {
            Logger.getLogger(DomTest.class.getName()).log(Level.SEVERE, null, ex);
        } catch (ParserConfigurationException ex) {
            System.err.println("Nevalidni dokument.");
            Logger.getLogger(DomTest.class.getName()).log(Level.SEVERE, null, ex);
        } catch (SAXException ex) {
            Logger.getLogger(DomTest.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IOException ex) {
            Logger.getLogger(DomTest.class.getName()).log(Level.SEVERE, null, ex);
        }

        
    }
/**
 * Counts the total number of pages in the bookshell
 * @return number of pages
 */
    public int countPages(){
//Doplnit implementaci viz JavaDoc
	return -1;
    }
            
    /**
     * Changes all occurancies of oldName in the element author to a newName
     * @param oldName original name of the author
     * @param newName new name of the author
     */
    public void changeAuthor(String oldName, String newName) {
	//Doplnit implementaci viz JavaDoc
    }
    /**
     * Constructor. Loads the content of the file into internal DOM Document representation.
     * @param fileName name of the input file
     * @throws ParserConfigurationException
     * @throws SAXException
     * @throws IOException 
     */
    public DomTest(String fileName) throws ParserConfigurationException, SAXException, IOException {
        DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
        
        dbf.setValidating(true);

        DocumentBuilder docBuilder = dbf.newDocumentBuilder();
        docBuilder.setErrorHandler(new ErrorHandler(){

            public void warning(SAXParseException exception) throws SAXException {
                System.err.println("Varovani: " + exception.getLocalizedMessage());
            }

            public void error(SAXParseException exception) throws SAXException {
                System.err.println("Chyba:" + exception.getLocalizedMessage());
            }

            public void fatalError(SAXParseException exception) throws SAXException {
                System.err.println("Hruba chyba: " + exception.getLocalizedMessage());
            }
        });
        
        doc = docBuilder.parse(fileName);
    }

    
    /**
     * Stores the internal DOM Document representation into the XML file
     * @param output name of the output XML file
     * @throws TransformerConfigurationException
     * @throws TransformerException 
     */
    public void serialize(String output) throws TransformerConfigurationException, TransformerException{
        TransformerFactory tf = TransformerFactory.newInstance();
        Transformer trans = tf.newTransformer();

        Source source = new DOMSource(doc.getDocumentElement());
        Result result = new StreamResult(output);

        trans.transform(source, result);
    }
    
    

}
